/* devmbsStatusSoft.c */
/* Example device support module */

#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "alarm.h"
#include "cvtTable.h"
#include "dbDefs.h"
#include "dbAccess.h"
#include "recGbl.h"
#include "recSup.h"
#include "devSup.h"
#include "link.h"
#include "mbsStatusRecord.h"
#include "epicsExport.h"

#include "typedefs.h"
#include "sys_def.h"
#include "sbs_def.h"
#include "s_daqst.h"

 extern int f_mbs_status(char*,s_daqst *); 

/* static s_daqst mbsstatus; */


/*Create the dset for devmbsStatusSoft */
static long init_record();
static long read_mbsStatus();
struct {
	long		number;
	DEVSUPFUN	report;
	DEVSUPFUN	init;
	DEVSUPFUN	init_record;
	DEVSUPFUN	get_ioint_info;
	DEVSUPFUN	read_mbsStatus;
}devmbsStatusSoft={
	5,
	NULL,
	NULL,
	init_record,
	NULL,
	read_mbsStatus,
};
epicsExportAddress(dset,devmbsStatusSoft);


static long init_record(pmbsStatus)
    struct mbsStatusRecord	*pmbsStatus;
{
  /*if(recGblInitConstantLink(&pmbsStatus->inp,DBF_DOUBLE,&pmbsStatus->val))*/
         pmbsStatus->udf = FALSE;
    return(0);
}

static long read_mbsStatus(pmbsStatus)

    struct mbsStatusRecord	*pmbsStatus;
{
    long status;
    char* curs;
    char node[64];
    s_daqst daqstatus; /* daqstatus on stack should have all fields 0*/
    daqstatus.bl_r_events=14000;
    daqstatus.bl_r_kbyte=1300;   
    /*curs = strstr(pmbsStatus->name,"@"); real name taken from description now!*/
    curs = strstr(pmbsStatus->desc,"@");
    strncpy(node,++curs,63);
    /*printf("read_mbsStatus in %s of %s\n",__FILE__,node);*/
    status=f_mbs_status(node,&daqstatus);
    if(status!=1) /* STC__SUCCESS=1*/
      {
        /* printf("ERROR in %s reading mbs status of node %s\n",__FILE__, node); */
        pmbsStatus->isavail=0;
        pmbsStatus->revents=0; /* maybe redundant, see above...*/
        pmbsStatus->rkbyte=0;
        pmbsStatus->udf = TRUE;
        return 0;
      }
    pmbsStatus->isavail=1;
    /*f_ut_seg_show (&daqstatus,0,0);*/
    pmbsStatus->val=daqstatus.bl_r_events;
    strncpy(pmbsStatus->mbsdate,daqstatus.c_date,63);
    strncpy(pmbsStatus->mbsfile,daqstatus.c_file_name,63);   
    pmbsStatus->isrun=daqstatus.bh_acqui_running;
    pmbsStatus->isfileopen=daqstatus.l_open_file;
    pmbsStatus->nevents=daqstatus.bl_n_events;
    pmbsStatus->revents=daqstatus.bl_r_events;
    pmbsStatus->nkbyte=daqstatus.bl_n_kbyte;
    pmbsStatus->rkbyte=daqstatus.bl_r_kbyte;
    pmbsStatus->nkbytefile=daqstatus.bl_n_kbyte_file;
    
    pmbsStatus->strun=daqstatus.bh_running[SYS__stream_serv];
    pmbsStatus->evrun=daqstatus.bh_running[SYS__event_serv];
    if(daqstatus.bh_running[SYS__stream_serv])
      {
        pmbsStatus->nkbyteserv=daqstatus.bl_n_strserv_kbytes;
        pmbsStatus->servscale= (daqstatus.bl_strsrv_scale ? 100/daqstatus.bl_strsrv_scale : 0);
        pmbsStatus->servratio= (daqstatus.bl_r_kbyte ? 100*daqstatus.bl_r_strserv_kbytes/daqstatus.bl_r_kbyte : 0);
      }
    else if(daqstatus.bh_running[SYS__event_serv])
      {
        pmbsStatus->nkbyteserv=daqstatus.bl_n_evserv_kbytes;
        pmbsStatus->servscale= (daqstatus.bl_evtsrv_scale ? 100/daqstatus.bl_evtsrv_scale : 0);
        pmbsStatus->servratio= (daqstatus.bl_r_kbyte ? 100*daqstatus.bl_r_evserv_kbytes/daqstatus.bl_r_kbyte : 0);
      }    
    else
      {
        pmbsStatus->servscale=0;
        pmbsStatus->servratio=0;
      }
    /*If return was succesful then set undefined false*/
    pmbsStatus->udf = FALSE;
    return(0);
}
